#ifndef BINLISTALGOR_H_ENI976
#define BINLISTALGOR_H_ENI976

#include "BinAllocator.h"
#include "TestAlgor.h"
#include "Particle.h"
#include <string>
#include <boost/timer.hpp>

class BinListAlgor : public TestAlgor {
public:
  virtual ~BinListAlgor() {}

  virtual std::string getName() const {
    return "Bin List w/cached";
  }

  virtual double operator()( int numLoops, float dt ) const {
    typedef std::list< Particle, BinAllocator<Particle> > PList;
    typedef PList::iterator PListIter;

    PList l;

    boost::timer timer;

    //Run our "game loop"
    for ( int c = 0; c < numLoops; ++c ) {
      l.push_back( Particle(
        Vector3D( getRandF(), getRandF(), getRandF() ),
        Vector3D( getRandF(), getRandF(), getRandF() ),
        getRandI(),
        getRandF(),
        getRandF() ) );

      PListIter iter = l.begin();
      while ( iter != l.end() ) {
        if ( iter->update2( dt ) ) {
          iter = l.erase( iter );
          //delete new Particle();
        } else
          ++iter;
      }
    }

    return timer.elapsed();
  }
};

#endif //BINLISTALGOR_H_ENI976
