#ifndef OBJECTLISTALGOR_H_ION499
#define OBJECTLISTALGOR_H_ION499

#include "TestAlgor.h"
#include "Particle.h"
#include <string>
#include <boost/timer.hpp>

class ObjectListAlgor : public TestAlgor {
public:
  virtual ~ObjectListAlgor() {}

  virtual std::string getName() const {
    return "List of Objects";
  }

  virtual double operator()( int numLoops, float dt ) const {
    typedef std::list< Particle > PList;
    typedef PList::iterator PListIter;

    PList l;

    boost::timer timer;

    //Run our "game loop"
    for ( int c = 0; c < numLoops; ++c ) {
      l.push_back( Particle(
        Vector3D( getRandF(), getRandF(), getRandF() ),
        Vector3D( getRandF(), getRandF(), getRandF() ),
        getRandI(),
        getRandF(),
        getRandF() ) );

      PListIter iter = l.begin();
      while ( iter != l.end() ) {
        if ( iter->update2( dt ) ) {
          iter = l.erase( iter );
          //delete new Particle();
        } else
          ++iter;
      }
    }

    double ret = timer.elapsed();

    //cout << "Objects at end: " << (unsigned int)l.size() << endl;
    cheatList.push_back( (int)l.size() );

    return ret;
  }
};

#endif //OBJECTLISTALGOR_H_ION499
