#ifndef POINTERLISTALGOR_H_VKS042
#define POINTERLISTALGOR_H_VKS042

#include "TestAlgor.h"
#include "Particle.h"
#include <string>
#include <boost/timer.hpp>

class PointerListAlgor : public TestAlgor {
public:
  virtual ~PointerListAlgor() {}

  virtual std::string getName() const {
    return "List of Pointers";
  }

  virtual double operator()( int numLoops, float dt ) const {
    typedef std::list< Particle* > PList;
    typedef PList::iterator PListIter;

    PList l;

    boost::timer timer;

    //Run our "game loop"
    for ( int c = 0; c < numLoops; ++c ) {
      l.push_back( new Particle(
        Vector3D( getRandF(), getRandF(), getRandF() ),
        Vector3D( getRandF(), getRandF(), getRandF() ),
        getRandI(),
        getRandF(),
        getRandF() ) );

      PListIter iter = l.begin();
      while ( iter != l.end() ) {
        if ( (*iter)->update2( dt ) ) {
          delete *iter;
          iter = l.erase( iter );
        } else
          ++iter;
      }
    }

    return timer.elapsed();

    for_each( l.begin(), l.end(), Deleter() );
  }
};

#endif //POINTERLISTALGOR_H_VKS042
